diff --git a/src/main/java/net/minecraft/core/player/inventory/slot/GuidebookSlot.java b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookSlot.java
similarity index 93%
rename from src/main/java/net/minecraft/core/player/inventory/slot/GuidebookSlot.java
rename to src/main/java/net/minecraft/client/gui/guidebook/GuidebookSlot.java
index 631e25bc5..5c974c092 100644
--- a/src/main/java/net/minecraft/core/player/inventory/slot/GuidebookSlot.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/GuidebookSlot.java
@@ -1,5 +1,6 @@
-package net.minecraft.core.player.inventory.slot;
+package net.minecraft.client.gui.guidebook;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.LocalPlayer;
 import net.minecraft.core.WeightedRandomBag;
 import net.minecraft.core.WeightedRandomLootObject;
@@ -8,9 +9,9 @@ import net.minecraft.core.data.registry.recipe.RecipeEntryBase;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.gamemode.Gamemode;
+import net.minecraft.core.player.inventory.slot.Slot;
 
 import java.util.List;
 import java.util.Random;
@@ -116,7 +117,8 @@ public class GuidebookSlot extends Slot
 	public boolean getIsDiscovered(Player player){
 		if (item == null || discovered) return true;
 		if (player instanceof LocalPlayer){
-			if (!((LocalPlayer) player).sender.minecraft.gameSettings.hideUndiscoveredItems.value) return true;
+			Minecraft mc = Minecraft.getMinecraft(this);
+			if (!mc.gameSettings.hideUndiscoveredItems.value) return true;
 		}
 		return player.getStat(item.getItem().getStat(StatList.STAT_PICKED_UP)) > 0 || player.getGamemode() == Gamemode.creative;
 	}
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
index c1d084552..ee9512c2e 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/CraftingPage.java
@@ -20,7 +20,7 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShaped;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryCraftingShapeless;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.GuidebookSlot;
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
index fd208ccdb..68385cd6a 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/mobs/MobPage.java
@@ -18,7 +18,7 @@ import net.minecraft.core.entity.animal.FireflyClusterMob;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.GuidebookSlot;
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
index 25779dde6..6e2d40968 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/BlastSmeltingPage.java
@@ -18,7 +18,7 @@ import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryBlastFurnace;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.GuidebookSlot;
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
index 29faa9f19..7aeb8a6cd 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/smelting/SmeltingPage.java
@@ -18,7 +18,7 @@ import net.minecraft.core.data.registry.recipe.SearchQuery;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryFurnace;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.GuidebookSlot;
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
index 43beb1898..aa9c5a0bc 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/trommeling/TrommelPage.java
@@ -21,7 +21,7 @@ import net.minecraft.core.data.registry.recipe.entry.RecipeEntryTrommel;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.player.inventory.slot.Slot;
-import net.minecraft.core.player.inventory.slot.GuidebookSlot;
+import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.opengl.GL11;
 
diff --git a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
index 49aea0227..45d7d43f4 100644
--- a/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
+++ b/src/main/java/net/minecraft/client/gui/hud/IngameHud.java
@@ -11,7 +11,7 @@ import java.util.Map;
 
 import com.mojang.logging.LogUtils;
 import net.minecraft.client.entity.player.MultiplayerLocalPlayer;
-import net.minecraft.client.gui.ChatScreen;
+import net.minecraft.client.gui.chat.ChatScreen;
 import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.PhotoModeScreen;
diff --git a/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java b/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
index 0fd3d1677..29434eb2c 100644
--- a/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
+++ b/src/main/java/net/minecraft/client/gui/options/components/DifficultyOptionComponent.java
@@ -3,7 +3,7 @@ package net.minecraft.client.gui.options.components;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.IntegerSliderElement;
 import net.minecraft.client.option.EnumOption;
-import net.minecraft.client.option.enums.Difficulty;
+import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.lang.I18n;
 
 public class DifficultyOptionComponent extends ButtonComponent {
diff --git a/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
new file mode 100644
index 000000000..5589746bb
--- /dev/null
+++ b/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -0,0 +1,136 @@
+package net.minecraft.client.net.command;
+
+import net.minecraft.client.Minecraft;
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.net.command.CommandSource;
+import net.minecraft.core.net.command.helpers.EntitySelector;
+import net.minecraft.core.util.helper.MathHelper;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.Dimension;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.Collection;
+import java.util.List;
+
+public class ClientCommandSource implements CommandSource {
+    private final Minecraft mc;
+
+    public ClientCommandSource(Minecraft mc) {
+        this.mc = mc;
+    }
+
+    @Override
+    public Collection<String> getPlayerNames() {
+        List<String> list = new ArrayList<>();
+        for (Player player : this.mc.theWorld.players) {
+            list.add(player.username);
+        }
+        return list;
+    }
+
+    @Override
+    public Collection<String> getEntitySuggestions() {
+        List<String> suggestions = new ArrayList<>(this.getPlayerNames());
+        if (this.mc.objectMouseOver != null && this.mc.objectMouseOver.entity != null) {
+            suggestions.add(EntitySelector.ENTITY_PREFIX + this.mc.objectMouseOver.entity.hashCode());
+        }
+        return suggestions;
+    }
+
+    @Override
+    public String toString() {
+        return "ClientCommandSource{" + this.mc + "}";
+    }
+
+    @Override
+    public @NotNull Player getSender() {
+        return this.mc.thePlayer;
+    }
+
+    @Override
+    public boolean hasAdmin() {
+        return true;
+    }
+
+    @Override
+    public @NotNull Vec3 getCoordinates(boolean offsetHeight) {
+        Vec3 position = this.getSender().getPosition(1.0f);
+        if (offsetHeight) return position.add(0.0f, -this.getSender().heightOffset, 0.0f);
+        return position;
+    }
+
+    @Override
+    public @NotNull Vec3 getBlockCoordinates() {
+        if (this.mc.objectMouseOver != null) {
+            return Vec3.getTempVec3(this.mc.objectMouseOver.x, this.mc.objectMouseOver.y, this.mc.objectMouseOver.z);
+        }
+        Vec3 playerCoordinates = this.getCoordinates(true);
+        return Vec3.getTempVec3(MathHelper.floor(playerCoordinates.x), MathHelper.floor(playerCoordinates.y), MathHelper.floor(playerCoordinates.z));
+    }
+
+    @Override
+    public boolean messageMayBeMultiline() {
+        return !this.mc.thePlayer.username.equals("pr_ib");
+    }
+
+    @Override
+    public void sendMessage(String message) {
+        if (!this.mc.isMultiplayerWorld()) this.mc.ingameHud.addChatMessage(message);
+    }
+
+    @Override
+    public void sendMessage(Player player, String message) {
+        if (player == this.mc.thePlayer) {
+            this.sendMessage(message);
+        }
+    }
+
+    @Override
+    public void sendMessageToAllPlayers(String message) {
+        this.mc.thePlayer.sendChatMessage(message);
+    }
+
+    @Override
+    public World getWorld() {
+        return this.mc.theWorld;
+    }
+
+    @Override
+    public World getWorld(int dimension) {
+        return this.mc.theWorld.dimension.id == dimension ? this.mc.theWorld : new World(this.mc.theWorld, Dimension.getDimensionList().get(dimension));
+    }
+
+    public void movePlayerToDimension(Player player, int dimension) {
+        Dimension lastDim = Dimension.getDimensionList().get(player.dimension);
+        Dimension newDim = Dimension.getDimensionList().get(dimension);
+        System.out.println("Switching to dimension \"" + newDim.getTranslatedName() + "\"!!");
+        player.dimension = dimension;
+        this.mc.theWorld.setEntityDead(player);
+        this.mc.thePlayer.removed = false;
+        double x = player.x;
+        double y = player.y + 64;
+        double z = player.z;
+        player.moveTo(x *= Dimension.getCoordScale(lastDim, newDim), y, z *= Dimension.getCoordScale(lastDim, newDim), player.yRot, player.xRot);
+        if (player.isAlive()) {
+            this.mc.theWorld.updateEntityWithOptionalForce(player, false);
+        }
+        World world = new World(this.mc.theWorld, newDim);
+        if (newDim == lastDim.homeDim) {
+            this.mc.changeWorld(world, "Leaving " + lastDim.getTranslatedName(), player);
+        } else {
+            this.mc.changeWorld(world, "Entering " + newDim.getTranslatedName(), player);
+        }
+        player.world = this.mc.theWorld;
+        if (player.isAlive()) {
+            player.moveTo(x, y, z, player.yRot, player.xRot);
+            this.mc.theWorld.updateEntityWithOptionalForce(player, false);
+        }
+    }
+
+    @Override
+    public String getName() {
+        return this.mc.thePlayer.username;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
index 92d104a91..7c4ca71ac 100644
--- a/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
+++ b/src/main/java/net/minecraft/client/net/handler/ClientPacketHandler.java
@@ -9,6 +9,7 @@ import net.minecraft.client.entity.player.RemotePlayer;
 import net.minecraft.client.gui.ConnectFailedScreen;
 import net.minecraft.client.gui.DownloadTerrainScreen;
 import net.minecraft.client.gui.PauseScreen;
+import net.minecraft.client.gui.chat.ChatSuggestionsElement;
 import net.minecraft.client.gui.guidebook.GuidebookScreen;
 import net.minecraft.client.gui.guidebook.PageManager;
 import net.minecraft.client.gui.guidebook.search.SearchPage;
@@ -43,67 +44,7 @@ import net.minecraft.core.net.NetworkManager;
 import net.minecraft.core.net.PlayerProfile;
 import net.minecraft.core.net.entity.NetEntityHandler;
 import net.minecraft.core.net.handler.PacketHandler;
-import net.minecraft.core.net.packet.AESSendKeyPacket;
-import net.minecraft.core.net.packet.AddEntityPacket;
-import net.minecraft.core.net.packet.AddItemEntityPacket;
-import net.minecraft.core.net.packet.AddMobPacket;
-import net.minecraft.core.net.packet.AddPaintingPacket;
-import net.minecraft.core.net.packet.AddParticlePacket;
-import net.minecraft.core.net.packet.AddPlayerPacket;
-import net.minecraft.core.net.packet.AnimatePacket;
-import net.minecraft.core.net.packet.BedMessagePacket;
-import net.minecraft.core.net.packet.BlockEventPacket;
-import net.minecraft.core.net.packet.BlockRegionUpdatePacket;
-import net.minecraft.core.net.packet.BlockUpdatePacket;
-import net.minecraft.core.net.packet.ChatPacket;
-import net.minecraft.core.net.packet.ChunkBlocksUpdatePacket;
-import net.minecraft.core.net.packet.ChunkVisibilityPacket;
-import net.minecraft.core.net.packet.ContainerAckPacket;
-import net.minecraft.core.net.packet.ContainerClosePacket;
-import net.minecraft.core.net.packet.ContainerOpenPacket;
-import net.minecraft.core.net.packet.ContainerSetContentPacket;
-import net.minecraft.core.net.packet.ContainerSetDataPacket;
-import net.minecraft.core.net.packet.ContainerSetSlotPacket;
-import net.minecraft.core.net.packet.CustomPayloadPacket;
-import net.minecraft.core.net.packet.DisconnectPacket;
-import net.minecraft.core.net.packet.EnitityEventPacket;
-import net.minecraft.core.net.packet.EntityNicknamePacket;
-import net.minecraft.core.net.packet.SetEntityDataPacket;
-import net.minecraft.core.net.packet.EntityTagDataPacket;
-import net.minecraft.core.net.packet.ExplosionPacket;
-import net.minecraft.core.net.packet.FlagOpenPacket;
-import net.minecraft.core.net.packet.GameRulePacket;
-import net.minecraft.core.net.packet.LoginPacket;
-import net.minecraft.core.net.packet.MapDataPacket;
-import net.minecraft.core.net.packet.MoveEntityPacket;
-import net.minecraft.core.net.packet.MovePlayerPacket;
-import net.minecraft.core.net.packet.Packet;
-import net.minecraft.core.net.packet.PhotoModePacket;
-import net.minecraft.core.net.packet.PlaySoundEffectDirectPacket;
-import net.minecraft.core.net.packet.PlaySoundEffectPacket;
-import net.minecraft.core.net.packet.PlayerGamemodePacket;
-import net.minecraft.core.net.packet.PlayerListPacket;
-import net.minecraft.core.net.packet.PreLoginPacket;
-import net.minecraft.core.net.packet.RecipeSyncPacket;
-import net.minecraft.core.net.packet.RemoveEntityPacket;
-import net.minecraft.core.net.packet.RespawnPacket;
-import net.minecraft.core.net.packet.SetCarriedItemPacket;
-import net.minecraft.core.net.packet.SetEntityMotionPacket;
-import net.minecraft.core.net.packet.SetEquippedItemPacket;
-import net.minecraft.core.net.packet.SetHealthPacket;
-import net.minecraft.core.net.packet.SetMobSpawnerPacket;
-import net.minecraft.core.net.packet.SetRidingPacket;
-import net.minecraft.core.net.packet.SetSpawnPositionPacket;
-import net.minecraft.core.net.packet.SetTimePacket;
-import net.minecraft.core.net.packet.SleepPacket;
-import net.minecraft.core.net.packet.StatisticPacket;
-import net.minecraft.core.net.packet.SyncIDsPacket;
-import net.minecraft.core.net.packet.TakeItemEntityPacket;
-import net.minecraft.core.net.packet.TeleportEntityPacket;
-import net.minecraft.core.net.packet.BlockEntityDataPacket;
-import net.minecraft.core.net.packet.UpdatePlayerProfilePacket;
-import net.minecraft.core.net.packet.WeatherEffectPacket;
-import net.minecraft.core.net.packet.WeatherStatusPacket;
+import net.minecraft.core.net.packet.*;
 import net.minecraft.core.player.gamemode.Gamemode;
 import net.minecraft.core.player.inventory.menu.AbstractContainerMenu;
 import net.minecraft.core.player.inventory.container.SimpleContainer;
@@ -1218,4 +1159,9 @@ public class ClientPacketHandler extends PacketHandler
             worldClient.addRainbow(rainbowTicks);
         }
     }
+
+    @Override
+    public void handleCommandManagerPacket(CommandManagerPacket packet) {
+        ChatSuggestionsElement.serverSuggestions = packet.suggestions;
+    }
 }
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index e22ff9c99..9492cf108 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -17,7 +17,7 @@ import net.minecraft.client.discord.RichPresenceHandlerThread;
 import net.minecraft.client.gui.hud.component.HudComponents;
 import net.minecraft.client.input.InputDevice;
 import net.minecraft.client.option.enums.Colorblindness;
-import net.minecraft.client.option.enums.Difficulty;
+import net.minecraft.core.enums.Difficulty;
 import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.option.enums.MipmapType;
 import net.minecraft.client.option.enums.RenderScale;
diff --git a/src/main/java/net/minecraft/core/achievement/stat/Stat.java b/src/main/java/net/minecraft/core/achievement/stat/Stat.java
index 0b4e4f960..a404feb9c 100644
--- a/src/main/java/net/minecraft/core/achievement/stat/Stat.java
+++ b/src/main/java/net/minecraft/core/achievement/stat/Stat.java
@@ -44,6 +44,10 @@ public class Stat
         return I18n.getInstance().translateKey(statKey);
     }
 
+    public String getStatKey() {
+        return statKey;
+    }
+
     public Stat setClientside()
     {
         clientside = true;
diff --git a/src/main/java/net/minecraft/core/entity/LightningEntity.java b/src/main/java/net/minecraft/core/entity/LightningEntity.java
index 55cfd57ef..6c9b2afdb 100644
--- a/src/main/java/net/minecraft/core/entity/LightningEntity.java
+++ b/src/main/java/net/minecraft/core/entity/LightningEntity.java
@@ -1,6 +1,6 @@
 package net.minecraft.core.entity;
 
-import net.minecraft.client.option.enums.Difficulty;
+import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.phys.AABB;
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index f238746cc..98992f22b 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -2,7 +2,6 @@ package net.minecraft.core.entity;
 
 import com.b100.utils.StringUtils;
 import com.mojang.nbt.CompoundTag;
-import net.minecraft.client.Minecraft;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.WeightedRandomLootObject;
diff --git a/src/main/java/net/minecraft/core/entity/PaintingEntity.java b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
index 062487d35..b587eb6ea 100644
--- a/src/main/java/net/minecraft/core/entity/PaintingEntity.java
+++ b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
@@ -14,7 +14,6 @@ import net.minecraft.core.world.World;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.material.Material;
 import net.minecraft.core.util.helper.DamageType;
-import net.minecraft.server.MinecraftServer;
 
 import java.util.*;
 
@@ -25,12 +24,14 @@ import java.util.*;
 
 public class PaintingEntity extends Entity
 {
+    public static final int DATA_ITEM_ID = 16;
+    public static final int DATA_ITEM_METADATA_ID = 17;
+
     private int updateCounter;
     public int direction;
     public int blockX;
     public int blockY;
     public int blockZ;
-    public ItemStack borderStack;
     public ArtType art;
 
     public PaintingEntity(World world)
@@ -63,6 +64,8 @@ public class PaintingEntity extends Entity
     @Override
     protected void defineSynchedData()
     {
+        entityData.define(DATA_ITEM_ID, 0);
+        entityData.define(DATA_ITEM_METADATA_ID, 0);
     }
 
     public void setDirection(int direction)
@@ -332,12 +335,23 @@ public class PaintingEntity extends Entity
     }
 
     public ItemStack getBorderStack() {
-        return borderStack;
+        int id = entityData.getShort(DATA_ITEM_ID);
+        int meta = Byte.toUnsignedInt(entityData.getByte(DATA_ITEM_METADATA_ID));
+
+        if (id != 0) {
+            return new ItemStack(id, 1, meta);
+        } else {
+            return null;
+        }
     }
+
     public void setStack(ItemStack stack){
-        borderStack = stack;
-        if (Global.isServer){
-            MinecraftServer.getInstance().playerList.sendPacketToAllPlayersInDimension(new AddPaintingPacket(this), world.dimension.id);
+        if (stack != null){
+            entityData.set(DATA_ITEM_ID, (short) stack.itemID);
+            entityData.set(DATA_ITEM_METADATA_ID, (byte) stack.getMetadata());
+        } else {
+            entityData.set(DATA_ITEM_ID, (short) 0);
+            entityData.set(DATA_ITEM_METADATA_ID, (byte) 0);
         }
     }
     private static final HashMap<String, NamespaceID> borderMaterialMap = new HashMap<>();
diff --git a/src/main/java/net/minecraft/core/entity/player/Player.java b/src/main/java/net/minecraft/core/entity/player/Player.java
index 5810f7bed..b580af12f 100644
--- a/src/main/java/net/minecraft/core/entity/player/Player.java
+++ b/src/main/java/net/minecraft/core/entity/player/Player.java
@@ -2,7 +2,7 @@ package net.minecraft.core.entity.player;
 
 import com.mojang.nbt.CompoundTag;
 import com.mojang.nbt.ListTag;
-import net.minecraft.client.option.enums.Difficulty;
+import net.minecraft.core.enums.Difficulty;
 import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.achievement.stat.Stat;
 import net.minecraft.core.achievement.stat.StatList;
diff --git a/src/main/java/net/minecraft/client/option/enums/Difficulty.java b/src/main/java/net/minecraft/core/enums/Difficulty.java
similarity index 93%
rename from src/main/java/net/minecraft/client/option/enums/Difficulty.java
rename to src/main/java/net/minecraft/core/enums/Difficulty.java
index 7330795f4..df3685602 100644
--- a/src/main/java/net/minecraft/client/option/enums/Difficulty.java
+++ b/src/main/java/net/minecraft/core/enums/Difficulty.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.option.enums;
+package net.minecraft.core.enums;
 
 import org.jetbrains.annotations.NotNull;
 
diff --git a/src/main/java/net/minecraft/core/net/command/CommandManager.java b/src/main/java/net/minecraft/core/net/command/CommandManager.java
new file mode 100644
index 000000000..3cd797ba5
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/CommandManager.java
@@ -0,0 +1,109 @@
+package net.minecraft.core.net.command;
+
+import com.mojang.brigadier.CommandDispatcher;
+import com.mojang.brigadier.ParseResults;
+import com.mojang.brigadier.exceptions.CommandSyntaxException;
+import net.minecraft.core.net.command.commands.*;
+import net.minecraft.server.net.command.commands.*;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.ArrayList;
+import java.util.Collection;
+
+@SuppressWarnings("unused")
+public class CommandManager {
+    private final boolean isServer;
+
+    public CommandManager(boolean isServer) {
+        this.isServer = isServer;
+    }
+
+    private final CommandDispatcher<CommandSource> DISPATCHER = new CommandDispatcher<>();
+    private static final Collection<CommandRegistry> externalCommands = new ArrayList<>();
+    private static final Collection<CommandRegistry> externalServerCommands = new ArrayList<>();
+
+    public void init() {
+        AchievementCommand.register(DISPATCHER);
+        ClearCommand.register(DISPATCHER);
+        KillCommand.register(DISPATCHER);
+        SeedCommand.register(DISPATCHER);
+        SetBlockCommand.register(DISPATCHER);
+        SummonCommand.register(DISPATCHER);
+        TeleportCommand.register(DISPATCHER);
+        MessageCommand.register(DISPATCHER);
+        SetSpawnCommand.register(DISPATCHER);
+        TimeCommand.register(DISPATCHER);
+        GameModeCommand.register(DISPATCHER);
+        WeatherCommand.register(DISPATCHER);
+        SpawnCommand.register(DISPATCHER);
+        PlaceCommand.register(DISPATCHER);
+        HelpCommand.register(DISPATCHER);
+        ChunkCommand.register(DISPATCHER);
+        GiveCommand.register(DISPATCHER);
+        GameRuleCommand.register(DISPATCHER);
+        FillCommand.register(DISPATCHER);
+        CloneCommand.register(DISPATCHER);
+        BiomeCommand.register(DISPATCHER);
+        SayCommand.register(DISPATCHER);
+        TellRawCommand.register(DISPATCHER);
+        TestForCommand.register(DISPATCHER);
+        DamageCommand.register(DISPATCHER);
+        HealCommand.register(DISPATCHER);
+
+        if (this.isServer) {
+            StopCommand.register(DISPATCHER);
+            OpCommand.register(DISPATCHER);
+            DeopCommand.register(DISPATCHER);
+            ListCommand.register(DISPATCHER);
+            DifficultyCommand.register(DISPATCHER);
+            ColorCommand.register(DISPATCHER);
+            NicknameCommand.register(DISPATCHER);
+            WhoIsCommand.register(DISPATCHER);
+            ScoreCommand.register(DISPATCHER);
+            MeCommand.register(DISPATCHER);
+            EmotesCommand.register(DISPATCHER);
+            for (CommandRegistry registry : externalServerCommands) {
+                registry.register(DISPATCHER);
+            }
+        }
+
+        for (CommandRegistry registry : externalCommands) {
+            registry.register(DISPATCHER);
+        }
+    }
+
+    public int execute(String s, CommandSource commandSource) throws CommandSyntaxException {
+        return this.DISPATCHER.execute(s, commandSource);
+    }
+
+    public CommandDispatcher<CommandSource> getDispatcher() {
+        return this.DISPATCHER;
+    }
+
+    @Nullable
+    public static <S> CommandSyntaxException getParseException(ParseResults<S> parseResults) {
+        if (!parseResults.getReader().canRead()) {
+            return null;
+        }
+        if (parseResults.getExceptions().size() == 1) {
+            return parseResults.getExceptions().values().iterator().next();
+        }
+        if (parseResults.getContext().getRange().isEmpty()) {
+            return CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownCommand().createWithContext(parseResults.getReader());
+        }
+        return CommandSyntaxException.BUILT_IN_EXCEPTIONS.dispatcherUnknownArgument().createWithContext(parseResults.getReader());
+    }
+
+    public static void registerCommand(CommandRegistry registry) {
+        externalCommands.add(registry);
+    }
+
+    public static void registerServerCommand(CommandRegistry registry) {
+        externalServerCommands.add(registry);
+    }
+
+    @FunctionalInterface
+    public interface CommandRegistry {
+        void register(CommandDispatcher<CommandSource> dispatcher);
+    }
+}
diff --git a/src/main/java/net/minecraft/core/net/command/CommandManagerPacketKeys.java b/src/main/java/net/minecraft/core/net/command/CommandManagerPacketKeys.java
new file mode 100644
index 000000000..190fe9b87
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/CommandManagerPacketKeys.java
@@ -0,0 +1,21 @@
+package net.minecraft.core.net.command;
+
+public class CommandManagerPacketKeys {
+    public static final String READER_CAN_READ = "a";
+    public static final String READER_CURSOR = "b";
+    public static final String READER_REMAINING_TEXT_LENGTH = "c";
+    public static final String READER_STRING = "d";
+    public static final String READER = "e";
+
+    public static final String VALUE = "f";
+    public static final String RANGE = "g";
+    public static final String RANGE_START = "h";
+    public static final String RANGE_END = "i";
+    public static final String TOOLTIP = "j";
+    public static final String LAST_CHILD = "k";
+    public static final String ARGUMENTS = "l";
+    public static final String SUGGESTIONS = "m";
+    public static final String EXCEPTIONS = "n";
+    public static final String USAGE = "o";
+    public static final String SUGGESTION_CONTEXT_START_POS = "p";
+}
\ No newline at end of file
diff --git a/src/main/java/net/minecraft/core/net/command/CommandSource.java b/src/main/java/net/minecraft/core/net/command/CommandSource.java
new file mode 100644
index 000000000..475eb99fb
--- /dev/null
+++ b/src/main/java/net/minecraft/core/net/command/CommandSource.java
@@ -0,0 +1,57 @@
+package net.minecraft.core.net.command;
+
+import net.minecraft.core.entity.player.Player;
+import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.phys.Vec3;
+import net.minecraft.core.world.World;
+import org.jetbrains.annotations.Nullable;
+
+import java.util.Collection;
+import java.util.Collections;
+
+public interface CommandSource {
+    Collection<String> getPlayerNames();
+
+    default Collection<String> getChatSuggestions() {
+        return this.getPlayerNames();
+    }
+
+    default Collection<String> getEntitySuggestions() {
+        return Collections.emptyList();
+    }
+
+    String toString();
+
+    @Nullable
+    Player getSender();
+
+    boolean hasAdmin();
+
+    @Nullable Vec3 getCoordinates(boolean offsetHeight);
+
+    @Nullable Vec3 getBlockCoordinates();
+
+    boolean messageMayBeMultiline();
+
+    void sendMessage(String message);
+
+    void sendMessage(Player player, String message);
+
+    default void sendTranslatableMessage(String message, Object... args) {
+        this.sendMessage(I18n.getInstance().translateKeyAndFormat(message, args));
+    }
+
+    default void sendTranslatableMessage(Player player, String message, Object... args) {
+        this.sendMessage(player, I18n.getInstance().translateKeyAndFormat(message, args));
+    }
+
+    void sendMessageToAllPlayers(String message);
+
+    World getWorld();
+
+    World getWorld(int dimension);
+
+    void movePlayerToDimension(Player player, int dimension);
+
+    String getName();
+}
